extends Area2D
signal drop_bomb

var speed = 80
var direction = 1

var can_fire = false

func _process(delta):
	position.x = position.x + direction * speed * delta
	if !$BelowMe.is_colliding():
		can_fire = true
#		update()

#func _draw():
#	if can_fire:
#		draw_circle(Vector2(0,0), 30, Color.red)


func destroy():
	speed = 0
	$CollisionShape2D.set_deferred("disabled", true)
	$AnimatedSprite.play("explode")
	yield($AnimatedSprite, "animation_finished")
	hide()
	queue_free()

func bounce():
	direction = -direction
	position.y = position.y + 10
	speed = speed + 10

func start(x, y, animation_name):
	position.x = x
	position.y = y
	$AnimatedSprite.play(animation_name)
	$BombTimer.wait_time = randf() * 5 + 1
	$BombTimer.start()

func stop():
	speed = 0
	$AnimatedSprite.playing = false
	$BombTimer.stop()
	
func _on_BombTimer_timeout():
	if can_fire and randf() > 0.5:
		emit_signal("drop_bomb", position)
	
	$BombTimer.wait_time = randf() * 5 + 1	
	$BombTimer.start()
